'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' This program using functions in wininet.dll
' to download any type of internet file from
' a source URL address.
'
VERSION	"0.0004"
CONSOLE
'
	IMPORT	"xst"
	IMPORT  "xsx"
	IMPORT	"kernel32"
	IMPORT  "wininet.dec"
'	IMPORT	"gdi32" 
'	IMPORT  "user32"
'
DECLARE FUNCTION  Entry ()
DECLARE FUNCTION  GetURLSource$ (URL$, fileName$, @bytesRead)
'
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	path$ = ""
	url$ = "http://photojournal.jpl.nasa.gov/tiff/PIA06141.tif"
	file$ = "PIA06141.tif"
	fileName$ = path$ + file$
	start = GetTickCount ()
	GetURLSource$ (url$, fileName$, @bytesRead)
	time# = (GetTickCount() - start)/1000.0
	PRINT "Download time (sec):"; time#

	PRINT
	a$ = INLINE$ ("Press ENTER to exit >")

	RETURN

END FUNCTION
'
'
' ##############################
' #####  GetURLSource$ ()  #####
' ##############################
'
' PURPOSE : download a file from a url address
' IN			: URL$ - internet address
' 					fileName$ - the path and filename to save file as
' OUT			: bytesRead - number of bytes read from url file
' RETURN  : return is complete url file as a string
'
FUNCTION  GetURLSource$ (URL$, fileName$, @bytesRead)

	FUNCADDR Open (XLONG, XLONG, XLONG, XLONG, XLONG)
	FUNCADDR OpenUrl (XLONG, XLONG, XLONG, XLONG, XLONG, XLONG)
	FUNCADDR ReadFile (XLONG, XLONG, XLONG, XLONG)
	FUNCADDR CloseHandle (XLONG)
	FUNCADDR Query (XLONG, XLONG, XLONG, XLONG, XLONG)
	FUNCADDR GetLastResponseInfo (XLONG, XLONG, XLONG)
	
	ULONG fs

	$INTERNET_FLAG_RELOAD = 0x80000000
	$INTERNET_OPEN_TYPE_PRECONFIG = 0
	$INTERNET_FLAG_EXISTING_CONNECT = 0x20000000

	IFZ URL$ THEN RETURN ""

	hWininetDll = LoadLibraryA (&"wininet.dll")
	IFZ hWininetDll THEN RETURN ""

	Open = GetProcAddress (hWininetDll, &"InternetOpenA")
	OpenUrl = GetProcAddress (hWininetDll, &"InternetOpenUrlA")
	ReadFile = GetProcAddress (hWininetDll, &"InternetReadFile")
	CloseHandle = GetProcAddress (hWininetDll, &"InternetCloseHandle")
	Query = GetProcAddress (hWininetDll, &"HttpQueryInfoA")
	GetLastResponseInfo = GetProcAddress (hWininetDll, &"InternetGetLastResponseInfoA") 

	IFZ Open THEN
		FreeLibrary (hWininetDll)
		RETURN ""
	ELSE
		IFZ OpenUrl THEN
			FreeLibrary (hWininetDll)
			RETURN ""
		ELSE
			IFZ ReadFile THEN
				FreeLibrary (hWininetDll)
				RETURN ""
			ELSE
				IFZ CloseHandle THEN
					FreeLibrary (hWininetDll)
					RETURN ""
				END IF
			END IF
		END IF
	END IF

	null$ = ""
	agent$ = "httpGetFile"
	hSession = @Open (&agent$, $INTERNET_OPEN_TYPE_PRECONFIG, &null$, &null$, 0)
	IFZ hSession THEN GOSUB GetSourceErr

	hOpenUrl = @OpenUrl (hSession, &URL$, &null$, 0, $INTERNET_FLAG_RELOAD | $INTERNET_FLAG_EXISTING_CONNECT, 0)
	IFZ hOpenUrl THEN GOSUB GetSourceErr
	
	buf$ = NULL$(256)
	l = LEN(buf$)
	ret = @Query (hOpenUrl, $$HTTP_QUERY_CONTENT_LENGTH, &buf$, &l, 0)
	IFZ ret THEN GOSUB GetSourceErr
	
	fs = ULONG(CSIZE$(buf$))
	PRINT "File size is"; fs; " bytes"
	
	PRINT "Starting download ..."
	
	buffer$ = NULL$ (fs+1)
	bytes = 0
	bytesRead = 0
	err = @ReadFile (hOpenUrl, &buffer$, LEN (buffer$), &bytesRead)
	IFZ err THEN GOSUB GetSourceErr
	
	IFZ bytesRead THEN
		text$ = "GetURLSource$ Error : Empty returned buffer."
		? text$
'		MessageBoxA (0, &text$, &"GetURLSource$ Error", $$MB_OK | $$MB_ICONEXCLAMATION)
 		GOTO end
	END IF

	IF fileName$ <> "" THEN
		err = XstSaveString (fileName$, buffer$)
		IF err THEN
			text$ = "GetURLSource$ Error : File not saved."
			? text$
'			MessageBoxA (0, &text$, &"GetURLSource$ Error", $$MB_OK | $$MB_ICONEXCLAMATION)
		END IF
	END IF

end:
	IF hOpenUrl <> 0 THEN @CloseHandle (hOpenUrl)
	IF hSession <> 0 THEN @CloseHandle (hSession)

	text$ = "Download done (" + STRING$(bytesRead) + " bytes)."
	? text$
'	MessageBoxA (0, &text$, &"GetURLSource Message", $$MB_OK | MB_ICONINFORMATION)

	RETURN buffer$

' ***** GetSourceErr *****
SUB GetSourceErr

' Use InternetGetLastResponseInfo () to retrieve error info

	err = 0
	buf$ = NULL$(1024)
	s = LEN(buf$)
	ret = @GetLastResponseInfo (&err, &buf$, &s)
	IF ret THEN ? "Error"; err; " ("; CSIZE$(buf$); ")"
	
'	XstGetSystemError (sysError)
'	XstSystemErrorNumberToName (sysError, @sysError$)
'	? sysError, sysError$

	IF hOpenUrl <> 0 THEN @CloseHandle (hOpenUrl)
	IF hSession <> 0 THEN @CloseHandle (hSession)

	RETURN ""
END SUB

END FUNCTION
END PROGRAM
